#include "main.h"

int get_data_from_condor(){
    bool rank_found = false;
    do {
        input ="";
        // read from terminal / get DATA from HTCondor
        getline(cin, input);

        // if input equals nothing set termination signal
        if (input == ""){
            input = termination_signal;
            char small_buffer[input.size()];
            strncpy(small_buffer, input.c_str(), sizeof(small_buffer));
            send(client, small_buffer, sizeof(small_buffer), 0);
        }
        else{
            if (end_of_header){
                input += "\n";
                // look for rank, and add the HPDA_RANK flag to the classAdd
                if(input.find(code_Rank + " =") == 0 && input.find(code_HPDA_RANK) == string::npos){
                    input = input + " + " + code_HPDA_RANK;
                    rank_found = true;
                }
                //find input files and transfer them to server
                if (input.find(code_Input_Files) == 0){
                    // small_buffer used to cut of string at end -> if buffer would be used there would be plenty of /x00
                    requested_files = input;
                }
                // skip hpda_requirement
                if(input.find(code_HPDA_REQUIREMENT) == 0){
                    input = "";
                }
                if ( !(input.find(code_HPDA_RANK + " =") != string::npos) && !(input.find(code_HPDA_REQUIREMENT + " =") != string::npos)){
			        data += input;
			    }
                if (input.find(code_directory) == 0){
			        absolute_path += input;
		        }
                //cout << input;
            }
            else {
                if (input.find("------") != string::npos){
                    end_of_header = true;
                }
            }
        }
        //logfile << data << endl;
    }while (input != termination_signal && input != "STOP SERVER");
    if (data == ""){
        cout << "Header not found / no valid input" << endl;
        return -1;
    }
    else if (requested_files == ""){
        cout << "Requested files not found!" << endl;
        return -1;
    }
    else if(!rank_found){
        data += "\nRank = ( 0.0 ) + HPDA_RANK\n";
    }
    return 0;

}

int main() {

    if (get_data_from_condor() == -1){
        return -1;
    }
    if (check_given_input_files() == -1){
        return -1;
    }
    // open connection
    client = open_connection(portNum);
    if (client == -1){
        return (-1);
    }
    //open private connection port for every request
    private_port = private_client_server_connection_get_port();
    if ( private_port == -1){
        close_connection();
        return -1;
    }
    if (close_connection() != 0){
        return -1;
    }
    client = open_connection(private_port);
    if (client == -1){
            return (-1);
    }
    //process data via connection
    if (send(requested_files) != 0){
        close_connection();
        return (-1);
    }
    if (send(termination_signal) != 0){
        close_connection();
        return (-1);
    }
    if (receive_information() != 0){
        close_connection();
        return -1;
    }
    //close connection
    return (close_connection());
}
