from navix.common import find_string_between, remove_blanks_from_string

##################################################################################################################
#
# Prepare list of files to search
#
##################################################################################################################


def create_file_list_to_search(queue_logging, thread_num, data):
    """
    :param queue_logging:
    :param thread_num:
    :param data:
    :return:
    creates an list with strings containing the requested files from given data
    -> afterwards it can be requested them from the caching management server
    """
    try:
        data = data.replace("\"\"", "\"")
    except Exception as e:
        queue_logging.put("WARNI: " + str(thread_num) + ": Failed to remove double \" from: "
                          + str(data)
                          + "\nPython-ERROR: " + str(e))

    try:
        data = find_string_between(queue_logging, thread_num, data, '"', '"')
    except Exception as e:
        queue_logging.put("ERROR: " + str(thread_num) + ": Function find_string_between raised an error!"
                          + "\nPython-ERROR: " + str(e))
        data = ""
    if data == "":
        queue_logging.put("ERROR: " + str(thread_num) + ": Can not interpret input_files string!")
        raise ValueError
    try:
        return get_files_to_search_from_data(queue_logging, thread_num, data)
    except Exception as e:
        queue_logging.put("ERROR: " + str(thread_num)
                          + ": Can not get file-list to search from given data -> Abort!"
                          + "\nPython-ERROR: " + str(e)
                          + "\ngiven data was : " + str(data))
        raise ValueError


def get_files_to_search_from_data(queue_logging, thread_num, data):
    """
    :param queue_logging:
    :param thread_num:
    :param data:
    :return:
    gets from given string by a hook the files which should be searched for
    """
    file_to_search_str = ""
    files_to_search_array = []
    # remove all blanks from string
    try:
        data = remove_blanks_from_string(data)
    except Exception as e:
        queue_logging.put("WARNI: " + str(thread_num) + ": Failed to remove blanks from: "
                          + str(data)
                          + "\nPython-ERROR: " + str(e))
    try:
        data = data.replace("\"\"", "\"")
    except Exception as e:
        queue_logging.put("WARNI: " + str(thread_num) + ": Failed to remove double \" from: "
                          + str(data)
                          + "\nPython-ERROR: " + str(e))
    # save requested files with prefix
    try:
        input_tmp = str(data).replace("\n", ",").replace(",,", ",")
        # TODO: Check whether input_tmp should include invalid addresses
    except Exception as e:
         queue_logging.put("ERROR: " + str(thread_num)
                              + ": Failed to save input files to local variable, data: "
                              + str(data)
                              + "\nPython-ERROR: " + str(e))
         raise
    while True:
        # check if files are separated by ","
        try:
            file_to_search_str = (find_string_between(queue_logging, thread_num, data, 'root:/', ','))
        except Exception as e:
            queue_logging.put("WARNI: " + str(thread_num)
                              + ": Failed while searching string between 'root:/'and ',' in: "
                              + str(data)
                              + "\nPython-ERROR: " + str(e))
        if file_to_search_str != "":
            # cut server address out -> only path to file requested
            try:
                files_to_search_array.append("/" + file_to_search_str.split("//", 1)[1])
            except Exception as e:
                queue_logging.put("WARNI: " + str(thread_num) + ": "
                                  + str(file_to_search_str) + " is invalid!"
                                  + "\nPython-ERROR: " + str(e))
            # remove file from input - check for next file
            try:
                data = data.replace("root:/" + file_to_search_str + ",", "")
            except Exception as e:
                queue_logging.put("WARNI: " + str(thread_num) + ": Failed to remove ',' from: "
                                  + str(file_to_search_str)
                                  + "\nPython-ERROR: " + str(e))
        else:
            # check if files ends with newline
            try:
                file_to_search_str = (find_string_between(queue_logging, thread_num, data, 'root:/', '\n'))
            except Exception as e:
                queue_logging.put("WARNI: " + str(thread_num)
                                  + ": Failed while searching string between 'root:/'and '\n' in: "
                                  + str(data)
                                  + "\nPython-ERROR: " + str(e))
            if file_to_search_str != "":
                # cut server address out -> only path to file requested
                try:
                    files_to_search_array.append("/" + file_to_search_str.split("//", 1)[1])
                except Exception as e:
                    queue_logging.put("WARNI: " + str(thread_num) + ": "
                                      + str(file_to_search_str) + " is invalid!"
                                      + "\nPython-ERROR: " + str(e))
                # if found remove filename from input list
                try:
                    data = data.replace("root:/" + str(file_to_search_str) + "\n", "")
                except Exception as e:
                    queue_logging.put("WARNI: " + str(thread_num) + ":  Failed to remove '\n' from: "
                                      + str(file_to_search_str)
                                      + "\nPython-ERROR: " + str(e))
        if file_to_search_str == "":
            # if it is still empty it should have read all -> break loop
            break
    try:
        splittedString = data.split('root://', 1)
        if len(splittedString) > 1:
            files_to_search_array.append("/" + ((splittedString[1]).split("//", 1)[1]))
    except Exception as e:
        queue_logging.put("WARNI: " + str(thread_num) + ":  Failed to append "
                          + str(("/" + ((data.split('root://', 1)[1]).split("//", 1)[1])))
                          + " to " + str(files_to_search_array)
                          + "\nPython-ERROR: " + str(e))
    return files_to_search_array, input_tmp
