from unittest import TestCase
from navix.logging import *
from tests.settings_for_test import SettingsForTesting as Settings

from navix.BufferingService import get_htcondor_information, get_xrootd_information, BufferingService
import multiprocessing
from time import sleep



class TestBufferingService(TestCase):
    maxDiff = None

    def setUp(self):
        # log file path
        log_file_s = 'NaviX_start_error.log'

        # create logger
        start_log = logging.getLogger(log_file_s)
        start_log.setLevel(logging.DEBUG)
        settings = Settings()
        log = Logging()

        self.thread_num = "TEST"
        self.settings = settings
        self.log = log
        self.logger = log.queue_logging
        self.log_file = log_file_s
        return

    def test_get_htcondor_information_correct(self):
        output = multiprocessing.Queue()
        get_htcondor_information(1, output, self.logger)
        self.assertEqual(output.get()[1], {'htcondor': 'not connected yet'})
        return

    # def test_get_htcondor_information_failed(self):
    #     output = multiprocessing.Queue()
    #     get_htcondor_information(1, output)
    #     self.assertEqual(output.get()[1], {'htcondor': 'not connected jet'})
    #     return

    def test_get_xrootd_information_correct(self):
        output = multiprocessing.Queue()
        get_xrootd_information(1, output, self.logger)
        self.assertEqual(output.get()[1], {'xrootd': 'not connected yet'})
        return

    # def test_get_xrootd_information_failed(self):
    #     output = multiprocessing.Queue()
    #     get_xrootd_information(1, output)
    #     self.assertEqual(output.get()[1], {'xrootd': 'not connected jet'})
    #     return

    # def test_write_to_database(self):
    #     return_code = BufferingService(self.log, self.settings).write_to_database()
    #     self.assertEqual(return_code, 0)
    #     return
