from unittest import TestCase
from navix.logging import *
from tests.settings_for_test import SettingsForTesting as Settings

from navix.replygenerator.htcondor_info import get_htcondor_information, connect_to_htcondor_buffering_service


class TestGetHtcondorInformation(TestCase):
    maxDiff = None

    def setUp(self):
        # log file path
        log_file_s = 'NaviX_start_error.log'

        # create logger
        start_log = logging.getLogger(log_file_s)
        start_log.setLevel(logging.DEBUG)
        settings = Settings()
        log = Logging()

        self.thread_num = "TEST"
        self.settings = settings
        self.logger = log.queue_logging

        self.htcondor_dict = dict()
        return

    def test_get_htcondor_information(self):
        # TODO connect to the buffering service for HTCondor information!
        htcondor_dict = get_htcondor_information(self.logger, self.thread_num, self.settings)
        # Currently, the dictionary should contain nothing, since the buffering service is not available
        self.assertEqual(htcondor_dict, dict())
        return

    def test_connect_to_htcondor_buffering_service(self):
        # TODO connect to the buffering service for HTCondor information!
        htcondor_dict = connect_to_htcondor_buffering_service(self.logger, self.thread_num, self.settings)
        # Currently, the dictionary should contain nothing, since the buffering service is not available
        self.assertEqual(htcondor_dict, dict())
        return
