from navix.logging import *
from navix.settings import Settings

class SettingsForTesting(object):

    def __init__(self):
        # log file path
        log_file_s = 'NaviX_start_error.log'

        # create logger
        start_log = logging.getLogger(log_file_s)
        start_log.setLevel(logging.DEBUG)
        settings = Settings.get_instance(start_log, "INFO")
        # this will raise an error if someone tries to initialize a new object, if there is already one
        ##########################################################
        #
        # stores all global config
        #
        ##########################################################
        self.host = settings.host
        self.port = settings.port
        self.termination_signal = settings.termination_signal
        self.xrootd_server_address = settings.xrootd_server_address
        self.server_weight = settings.server_weight
        self.pyxrootd_timeout = settings.pyxrootd_timeout
        self.known_servers = settings.known_servers
        self.compile_hook = settings.compile_hook
        self.source_path_translate_hook = settings.source_path_translate_hook
        self.target_compile_translate_hook = settings.target_compile_translate_hook
        self.source_path_update_hook = settings.source_path_update_hook
        self.target_compile_update_hook = settings.target_compile_update_hook
        self.source_path_finalize_hook = settings.source_path_finalize_hook
        self.target_compile_finalize_hook = settings.target_compile_finalize_hook
        self.source_path_hook_main = settings.source_path_hook_main
        self.time_before_adding_additional_resources = settings.time_before_adding_additional_resources
        self.log_level = "INFO"
        self.cached_percentage_before_adding_to_requirement = settings.cached_percentage_before_adding_to_requirement
        self.working_directory = settings.working_directory
        self.requested_files = settings.requested_files
        self.requested_files_tmp = settings.requested_files_tmp
        self.requested_files_mon = settings.requested_files_mon
        self.hpda_rank = settings.hpda_rank
        self.hpda_requirement = settings.hpda_requirement
        self.rank = settings.rank
        self.hpda_timestamp = settings.hpda_timestamp
        self.start_job_timestamp = settings.start_job_timestamp
        self.completion_timestamp = settings.completion_timestamp
        self.file_found_on_server = settings.file_found_on_server
        self.hpda_rank_monitoring = settings.hpda_rank_monitoring
        self.global_job_id = settings.global_job_id
        self.remote_user_cpu = settings.remote_user_cpu
        self.remote_sys_cpu = settings.remote_sys_cpu
        self.requested_cpus = settings.requested_cpus
        self.network_input_mb = settings.network_input_mb
        self.last_remote_host = settings.last_remote_host
        self.last_remote_ip = settings.last_remote_ip

    def get_instance(self):
        return self
